import "./styles.scss";
import { Editor, EditorFactory, KogitoEditorChannelApi, KogitoEditorEnvelopeApi, KogitoEditorEnvelopeContextType } from "../api";
import { ApiDefinition, EnvelopeBus } from "@kie-tools-core/envelope-bus/dist/api";
import { EnvelopeApiFactory } from "@kie-tools-core/envelope";
import { EditorEnvelopeViewApi } from "./EditorEnvelopeView";
import { KeyboardShortcutsService } from "@kie-tools-core/keyboard-shortcuts/dist/envelope/KeyboardShortcutsService";
export declare function init(args: {
    container: HTMLElement;
    bus: EnvelopeBus;
    editorFactory: EditorFactory<Editor, KogitoEditorChannelApi>;
    keyboardShortcutsService?: KeyboardShortcutsService;
}): void;
export declare function initCustom<E extends Editor, EnvelopeApi extends KogitoEditorEnvelopeApi & ApiDefinition<EnvelopeApi>, ChannelApi extends KogitoEditorChannelApi & ApiDefinition<ChannelApi>>(args: {
    container: HTMLElement;
    bus: EnvelopeBus;
    apiImplFactory: EnvelopeApiFactory<EnvelopeApi, ChannelApi, EditorEnvelopeViewApi<E>, KogitoEditorEnvelopeContextType<ChannelApi>>;
    keyboardShortcutsService?: KeyboardShortcutsService;
}): Promise<import("@kie-tools-core/envelope-bus/dist/envelope").EnvelopeClient<EnvelopeApi, ChannelApi>>;
export { EditorEnvelopeViewApi } from "./EditorEnvelopeView";
export * from "./KogitoEditorEnvelopeApiImpl";
export * from "./LoadingScreen";
//# sourceMappingURL=index.d.ts.map